#[derive(Hash, Eq, PartialEq, Debug, Clone)]
pub struct Vector2 {
    pub x: i32,
    pub y: i32,
}
//Implement vector 2 functions
impl Vector2 {   

    pub fn right() -> Vector2 {
        Vector2{x:1, y:0}
    }
    pub fn left() -> Vector2 {
        Vector2{x:-1, y:0}
    }
    pub fn up() -> Vector2 {
        Vector2{x:0, y:1}
    }
    pub fn down() -> Vector2 {
        Vector2{x:0, y:-1}
    }
    pub fn zero() -> Vector2 {
        Vector2{x:0, y:0}
    }
    pub fn add(&self, other: &Self) -> Vector2 {
        Vector2{x: self.x + other.x, y: self.y + other.y}
    }
    pub fn distance(&self, to: &Self) -> i32{
        ((to.x - self.x.abs()) + (to.y - self.y.abs()))
    }
}
